package de.moritzruth.dracula_musical.device

import de.moritzruth.theaterdsl.device.Device
import de.moritzruth.theaterdsl.device.PercentageDV
import de.moritzruth.theaterdsl.dmx.DmxAddress
import de.moritzruth.theaterdsl.dmx.DmxDataWriter
import de.moritzruth.theaterdsl.dmx.DmxValue
import kotlinx.collections.immutable.persistentSetOf

class AdjFogFury3000(override val firstChannel: DmxAddress) : Device {
    override val numberOfChannels = 4u

    val power = PercentageDV()

    override val dvs = persistentSetOf(power)
    override fun writeDmxData(writer: DmxDataWriter, isLightBehindCurtainOn: Boolean) {
        writer.writePercentage(power.getCurrentValue())
        writer.writeRaw(DmxValue(255u)) // interval (ignored)
        writer.writeRaw(DmxValue(255u)) // duration = constant
    }
}