package de.moritzruth.dracula_musical.song

import de.moritzruth.dracula_musical.device.BlinderBars
import de.moritzruth.dracula_musical.device.StairvilleSplb
import de.moritzruth.theaterdsl.show.CurtainState
import de.moritzruth.theaterdsl.show.PropPosition
import de.moritzruth.theaterdsl.show.SceneBuilderContext
import de.moritzruth.theaterdsl.show.StepCue
import de.moritzruth.theaterdsl.value.percent
import kotlin.time.Duration.Companion.minutes
import kotlin.time.Duration.Companion.seconds

fun SceneBuilderContext.songAdelIstGeil() {
    // TODO

    step(StepCue.MusicStart("Adel ist geil", 2.minutes + 15.seconds)) {
        curtainState = CurtainState.CLOSED

        props {
            it[PropPosition.BACKDROP] = "Irrenanstalt"
            it[PropPosition.CENTER] = "Medikamenten-Schrank"
        }

        onRun {
            BlinderBars.all {
                it.brightness.fade(25.percent, 5.seconds)
                it.preset.static(StairvilleSplb.Preset.STUB)  // jumpy, green
                it.presetSpeed.static(40.percent)
            }
        }
    }

    step(StepCue.MusicEnd) {
        BlinderBars.all { it.brightness.off(1.seconds) }
    }
}