package de.moritzruth.dracula_musical.song

import de.moritzruth.dracula_musical.device.BlinderBars
import de.moritzruth.dracula_musical.device.CoemarProWash
import de.moritzruth.dracula_musical.device.StairvilleSplb
import de.moritzruth.dracula_musical.device.Washs
import de.moritzruth.theaterdsl.show.SceneBuilderContext
import de.moritzruth.theaterdsl.show.StepCue
import de.moritzruth.theaterdsl.value.percent
import kotlin.time.Duration.Companion.minutes
import kotlin.time.Duration.Companion.seconds

fun SceneBuilderContext.songRepriseDuett() {
    lightStep(StepCue.MusicStart("Reprise: Duett", 1.minutes + 15.seconds)) {
        Washs.both {
            it.pointAtCeiling()
            it.colorWheelMode.static(CoemarProWash.ColorWheelMode.White)
            it.magenta.static(100.percent)
            it.brightness.fade(100.percent, 10.seconds)
        }

        BlinderBars.all {
            it.preset.static(StairvilleSplb.Preset.STUB)  // dreamy, flowy, pink, warm
            it.presetSpeed.static(10.percent)
            it.brightness.fade(25.percent, 5.seconds)
        }
    }

    lightStep(StepCue.MusicEnd) {
        BlinderBars.all { it.brightness.off(4.seconds) }
        Washs.both { it.brightness.off(4.seconds) }
    }
}