package de.moritzruth.dracula_musical.song

import de.moritzruth.dracula_musical.device.BlinderBars
import de.moritzruth.dracula_musical.device.FrontLights
import de.moritzruth.dracula_musical.device.StairvilleSplb
import de.moritzruth.theaterdsl.show.SceneBuilderContext
import de.moritzruth.theaterdsl.show.StepCue
import de.moritzruth.theaterdsl.value.percent
import kotlin.time.Duration.Companion.minutes
import kotlin.time.Duration.Companion.seconds

fun SceneBuilderContext.songStreitDerVampire() {
    lightStep(StepCue.MusicStart("Streit der Vampire", 1.minutes + 30.seconds)) {
        BlinderBars.all {
            it.preset.static(StairvilleSplb.Preset.STUB)  // chase, single direction
            it.presetSpeed.static(40.percent)
            it.brightness.fade(25.percent, 1.seconds)
        }

        FrontLights.left { it.brightness.sine(5.seconds, 50.percent, 100.percent, 50.percent) }
        FrontLights.right { it.brightness.sine(5.seconds, 50.percent, 100.percent, 100.percent) }
    }

    lightStep(StepCue.MusicEnd) {
        BlinderBars.all { it.brightness.off(2.seconds) }

        FrontLights.left { it.brightness.off(3.seconds) }
        FrontLights.right { it.brightness.off(3.seconds) }
    }
}