package de.moritzruth.theaterdsl.dmx

import de.moritzruth.theaterdsl.value.Percentage

interface DmxDataWriter {
    fun writeRaw(value: DmxValue)

    fun writePercentage(value: Percentage) = writeRaw(value.toDmxValue())

    fun writeHighByte(value: UShort) = writeRaw(DmxValue(value.toUInt().shr(8).toUByte()))
    fun writeLowByte(value: UShort) = writeRaw(DmxValue(value.toUByte()))
}
